
// Compiler avec valac -o demosignaux demosignaux.vala

public class Emetteur : Object
{
	public signal void lancer(string s);

	public void emission()
	{
		lancer("Programmez!");
	}
}

public class Recepteur : Object
{
	public void reception(string s)
	{
		string texte = s + " abonnez vous ! :-)\n";
		stdout.printf("%s", texte);
	}
}

static void reception_statique(string s)
{
	string texte = "Abonnez-vous pour dix ans a ";
	texte += s;
	texte += "\n";
    stdout.printf("%s", texte);
}

public class DemoSignal : Object
{
	static int main(string[] args)
	{
        var emetteur = new Emetteur();
		var recepteur = new Recepteur();
        emetteur.lancer.connect(recepteur.reception);
		emetteur.lancer.connect(reception_statique);
		emetteur.lancer.connect ((s, i) => stdout.printf("ou plus :-)\n"));
        emetteur.emission();
		return 0;
    }
}
